{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
Unit CDTCV;

Interface

Uses
  Dos, DosX, xCrt;

Type
  Str60   = String[60];
  Str8    = String[8];
  Str80   = String[80];
  Str4    = String[4];
  Str45   = String[45];
  Str50   = String[50];
  Str2	  = String[2];
  Str6    = String[6];
  SoundType = (sSilence, sNormalSound, sAlarm);
  ErrorType = (eNone, eVerify, eDiskChange);
  VideoModeRec = Record
    C : Word;
    S : Str6;
  End;

Const
  VideoModeArray : Array[0..10] Of VideoModeRec = (
    (C: BW80;     S: 'BW80'),   (C: CO80;     S: 'CO80'),
    (C: CO80x50;  S: '80X50'),
    (C: CO80x60;  S: '80X60'),  (C: CO100x40; S: '100X40'),
    (C: CO100x75; S: '100X75'), (C: CO132x25; S: '132X25'),
    (C: CO132x28; S: '132X28'), (C: CO132x44; S: '132X44'),
    (C: CO132x50; S: '132X50'), (C: CO132x60; S: '132X60')
  );
  RWStatus : Array[False..True] Of String[10] = ('writing...', 'reading...');
  ErrTxt0 = 'Dos 3.30 or above required';
  Errtxt1 = ' or is non-removable';
  Errtxt2 = 'Drive types or diskette types is not compatible';
  ErrTxt3 = 'There is only support for 320K, 360K, 720K, 1.2M, 1.44M and 2.88M';
  tSource           : String[45] = 'Insert SOURCE diskette in drive  :';
  tTarget           : String[40] = 'Insert TARGET diskette in drive  :';
  tDiskTypeMismatch : String[35] = 'Disk Format do not match, Remove Disk.';
  tNewDisk          : String[35] = 'Insert NEW Disk, or Esc to Abort';
  tCopyAnother      : String[30] = 'Copy another diskette Y/N ?';
  tRemoveSource     : Str60      = 'Remove SOURCE from drive  : or press Esc to Quit';
  tRemoveTarget     : Str60      = 'Remove TARGET from drive  : or press Esc to Quit';
  tRemoveDisk       : Str60      = 'Remove diskette from drive  : or press Esc to Quit';
  tCorrect          : String[30] = 'Correct, or press Esc to Abort';
  tRetryAbortIgnore : String[45] = '(R)etry, (I)gnore, (A)lways or Esc to Abort';
  tErrorWrite       : String[40] = 'Error Writing diskette, try again [Y/N] ?';
  tVerifyError      : String[12] = 'Verify Error';
  tUnLabeled        : String[9]  = 'unlabeled';

  ChangeLineSupport : Array[1..2] Of Boolean = (True, True);
  SwapToDisk    : Boolean    = False;
  MemAllocated  : Boolean    = False;
  Writing       : Boolean    = False;
  StartCopy     : Boolean    = True;
  LabelChanged  : Boolean    = False;
  MultiCopy     : Boolean    = False;    { /M }

  { XMM Static Vars }
  SwapToXMS     : Boolean    = False;
  XmsAllocated  : Boolean    = False;
  FreeExtended  : LongInt    = 0;
  SwapMem       : LongInt    = 0;
  XMSAllocSize  : LongInt    = 0;

  SwapDir       : DirStr     = '';
  SwapFName     : String[12] = '';
  Setup         : String[5]  = 'SETUP';
  { Commandline switches (static) }
  Alarm         : SoundType  = sAlarm;   { /A{0..2}
  UseChangeLine : Boolean    = True;     { /C }
  FullScreen    : Boolean    = True;     { /E }
  ForcedFormat  : Boolean    = False;    { /F }
  FatSelect     : Boolean    = True;     { /FS }
  Ignore	: Boolean    = False;    { /I }
  UseKeyboard   : Boolean    = False;    { /K }
  ShowLabel     : Boolean    = True;     { /L }
  NoOfCopies    : Word       = 1;        { /M }
  Skewing       : Boolean    = False;    { /R }
  SlowRW        : Boolean    = False;    { /RS}
  VideoMode     : Str6       = '';       { /S }
  Verify        : Boolean    = False;    { /V Controlled also by DOS VERIFY state}
  UseXms        : Boolean    = True;     { /X }

Var
  Buf :  Array[1..80*2+2] Of PZeroArray;
  int23,  ExitProcPtr : Pointer;
  SourceP, TargetP : ^DeviceParams;
  SwapF : File;
  DriveS, DriveT, DiskType, BufId, DiskId,  BadSectors : Byte;
  TrackSize, DosVer, DevicePSize : Word;
  DSizeS, DSizeT, RealDSizeS, DosAllocSize : Longint;
  ErrorRes : ErrorType;
  VideoModeC : Word;
  tText        : Str80;
  tErrorPrompt : Str60;
  SaveSetup : Boolean;


Implementation


End.
